
/*******************************  LICENSE  *******************************

 * (C) Copyright 1996-2016 ECMWF.
 * 
 * This software is licensed under the terms of the Apache Licence Version 2.0
 * which can be obtained at http://www.apache.org/licenses/LICENSE-2.0. 
 * In applying this licence, ECMWF does not waive the privileges and immunities 
 * granted to it by virtue of its status as an intergovernmental organisation nor
 * does it submit to any jurisdiction.

 *******************************  LICENSE  *******************************/

/*! \fileXmlBasicNodeAttributes.h
    \brief Definition of XmlBasicNode Attributes class.

    This file is automatically generated.
    Do Not Edit!

    Generated: 
*/
   

#ifndef XmlBasicNodeAttributes_H
#define XmlBasicNodeAttributes_H

#include "magics.h"
#include "Colour.h"
namespace magics {

class XmlNode;
class XmlBasicNodeAttributes 
{
public:
//  --  constructor
    XmlBasicNodeAttributes();
    
//  --  destructor
    virtual ~XmlBasicNodeAttributes();
    
    virtual void set(const std::map<std::string, std::string>&);
    virtual void set(const XmlNode&);
    virtual void copy(const XmlBasicNodeAttributes&);
    virtual bool accept(const std::string&);

    void setTag(const std::string& tag) { tag_ = tag; }

public:
	//  --  method
	virtual void print(std::ostream&) const;
	virtual void toxml(std::ostream& out) const;
	//  --  members:
	string tag_;
	bool standalone_;
	string standalone_path_;
	string standalone_format_;
	double standalone_width_;
	double standalone_height_;
	string bottom_;
	string left_;
	string width_;
	string height_;
	string margin_bottom_;
	string margin_left_;
	string margin_right_;
	string margin_top_;
	string border_bottom_;
	string border_left_;
	string border_right_;
	string border_top_;
	bool border_;
	bool blanking_;
	int border_thickness_;
	string padding_bottom_;
	string padding_left_;
	string padding_right_;
	string padding_top_;
	DisplayType display_;
	unique_ptr<Colour> background_;
	unique_ptr<Colour> border_colour_;
	LineStyle border_style_;
	unique_ptr<Colour> padding_colour_;
	 

private:
	friend ostream& operator<<(ostream& s,const XmlBasicNodeAttributes& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif

